//
// ping.hh        : Ping Include File
// author         : Fabio Silva
//
// Copyright (C) 2000-2001 by the Unversity of Southern California
// $Id: ping.hh,v 1.1 2001/11/21 19:51:23 fabio Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#include <stdlib.h>
#include <stdio.h>
#include "dr.hh"

#define COUNTER_KEY 3601
#define TIME_KEY    3602

extern NRSimpleAttributeFactory<char *> TargetAttr;
extern NRSimpleAttributeFactory<int> AppCounterAttr;
extern NRSimpleAttributeFactory<void *> TimeAttr;

class EventTime {
public:
  long seconds;
  long useconds;
};

class MyReceive;

class PingApp {
public:
  PingApp();
  void run(int argc, char **argv);
  void recv(NRAttrVec *data, NR::handle my_handle);

private:
  // NR Specific variables
  NR *dr;  
  MyReceive *mr;
  handle subHandle;
  handle pubHandle;
  u_int16_t diffusion_port;

  // Ping App variables
  int last_seq_sent;
  int last_seq_recv;
  int num_msg_recv;
  int first_msg_recv;

  void ParseLine(int argc, char **argv, u_int16_t *diffusion_port);
  void usage(char *s);
  handle setupSubscription();
  handle setupPublication();
};

class MyReceive : public NR::Callback {
public:
  PingApp *app;

  void recv(NRAttrVec *data, NR::handle my_handle);
};
